using System;
using System.Collections.Generic;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Windows.Threading;

namespace DispatcherExamples2
{

    // Example C-5. Using a DispatcherTimer

    partial class MyWindow : Window
    {

        DispatcherTimer dt;
        public MyWindow()
        {
            InitializeComponent();

            dt = new DispatcherTimer();
            dt.Tick += dt_Tick;
            dt.Interval = TimeSpan.FromSeconds(2);
            dt.Start();
        }

        Random rnd = new Random();
        void dt_Tick(object sender, EventArgs e)
        {
            byte[] vals = new byte[3];
            rnd.NextBytes(vals);
            Color c = Color.FromRgb(vals[0], vals[1], vals[2]);

            // OK to touch UI elements, as the DispatchTimer
            // calls us back on the UI thread
            this.Background = new SolidColorBrush(c);
        }
    }

    // End of Example C-5.
}